<template>
  <div class="bg-white">
    <header class="bg-white w-full px-4 fixed top-0 left-0 z-[21]">
      <div
        class="grid grid-cols-3 justify-items-stretch py-4 place-items-center"
      >
        <nuxt-link to="/">
          <font-awesome-icon
            :icon="['fas', 'chevron-left']"
            color="#000"
            class="text-[5vw]"
          />
        </nuxt-link>
        <div class="justify-self-center text-[4.1vw]">
          {{ filtered.toString().replaceAll("__n__gt", "") }}
        </div>
        <button class="searchImage justify-self-end" @click="toggleIsSearching">
          <font-awesome-icon
            :icon="['fas', 'magnifying-glass']"
            color="#5C89FB"
            class="text-[6vw]"
          />
        </button>
      </div>
      <div
        class="search-field flex justify-between gap-2 items-center absolute top-0 left-0 z-10 transition-all duration-500 py-2"
        :class="{
          'translate-y-0': isSearching,
          '-translate-y-full': !isSearching,
        }"
      >
        <form
          class="basis-10/12 flex gap-1 bg-gray-100 rounded-full h-[11vw] items-center"
          @submit.prevent="updateSearchResult"
        >
          <div class="p-[3vw] flex items-center">
            <font-awesome-icon
              :icon="['fas', 'magnifying-glass']"
              class="text-[6vw] text-[grey]"
            />
          </div>
          <el-input
            @keyup="searching"
            v-model="searchModel"
            :placeholder="$t('Search All Games')"
            ref="gameInputRef"
            class="search-game-input"
          />
          <el-button
            :icon="Search"
            type="primary"
            circle
            native-type="submit"
            class="game-search-button"
            style="margin-right: 0.25rem"
          />
        </form>
        <button class="basis-1/12 text-[3.3vw]" @click="toggleIsSearching">
          Cancel
        </button>
      </div>
    </header>
    <main
      class="game-container"
      v-loading="isLoading"
      v-infinite-scroll="gameLoading"
    >
      <div
        v-for="game in gameReadyToRender"
        :key="game.GameId"
        @click="handleGameClicked(game)"
        class="bg-white rounded-lg game-card overflow-hidden"
      >
        <div class="flex flex-col justify-center relative">
          <div class="absolute top-0 w-full z-10">
          <div v-if="game.IsNewGame" class="w-1/2 aspect-[1/0]">
            <img
              class="w-10 h-full object-contain pt-1 pl-1"
              :src="getAssetImage('assets/theme/common/icon/new_icon.svg')"
            />
          </div>
          <div v-if="game.IsHotGame" class="w-1/2 aspect-[1/0]">
            <img
              class="w-10 h-full object-contain pt-1 pl-1"
              :src="getAssetImage('assets/theme/common/icon/hot_icon.svg')"
            />
          </div>
        </div>
          <!-- <IconFavorite
            :gameData="game"
            :checkIsFavourite="checkIsFavourite"
            :redirectToLogin="redirectToLogin"
            :setAndUnsetGameToFavourite="setAndUnsetGameToFavourite"
            :ForMobile="true"/> -->
          <el-image
            :src="isImageVersionExist(game.GameIconUrl)"
            lazy
            class="h-[28vw] w-full game-card__game-icon"
          >
            <template #placeholder>
              <div class="flex w-full h-full items-center justify-center">
                <span class="text-gray-500">loading...</span>
              </div>
            </template>
            <template #error>
              <span></span>
            </template>
          </el-image>
          <div class="text-[3.7vw] text-gray-600 text-center p-2">
            {{ game.GameName }}
          </div>
        </div>
      </div>
      <div
        v-if="!gameCollection.length && !isLoading"
        class="w-full absolute left-0 text-center"
      >
        {{ $t("no_data") }}
      </div>
    </main>
  </div>
</template>
<script lang="ts">
import _ from "lodash";
import { defineComponent, ref, onMounted, watch, computed } from "vue";
import { useRouter } from "vue-router";
import { Search } from "@element-plus/icons-vue";
import { store } from "@/store";
import {
  handleGameEntryOpenWindow,
  useGameEntryComponent,
} from "@/composables/useTheme";
import { IGameBsi } from "@/models/bsiGameList";
import commonHelper from "@/utils/commonHelper";
import { IGame } from "~~/models/IGetPlayableGamesResponse";

export default defineComponent({
  name: "MGameEntryComponent",
  setup() {
    const router = useRouter();
    const providerModel = ref<string>();
    const gameInputRef = ref();
    const {
      filtered,
      isLoading,
      headerTab,
      gameTypes,
      providers,
      // initialGameEntry,
      searchedGame,
      tabInitial,
      subTabInitial,
      authenticated,
      handleSearchGame,
      handleSelectedTabOption,
      getGameEntryFiltered,
      gameCollection,
      updateSearchResult,
    } = useGameEntryComponent();

    const { setAndUnsetGameToFavourite, checkIsFavourite, redirectToLogin } =
      useAddToFavorite();
    const isSearching = ref<boolean>(false);
    const searchModel = ref(searchedGame.value);
    const toggleIsSearching = () => {
      searchedGame.value = "";
      searchModel.value = "";
      isSearching.value = !isSearching.value;
      if (isSearching.value) {
        if (gameInputRef.value) {
          gameInputRef.value.focus();
        }
      } else {
        updateSearchResult();
      }
    };

    const handleGameClicked = (game: IGame) => {
      if (authenticated) {
        handleGameEntryOpenWindow(game, 550, 850);
      } else {
        router.push("/login");
      }
    };

    const { getAssetImage } = commonHelper;

    onMounted(async () => {
      const isGameType = filtered.value.includes("__n__gt");
      if (isGameType) {
        const gameType = filtered.value.toString().replaceAll("__n__gt", "");
        await getGameEntryFiltered({
          Type: gameType === "Favorite" ? "Favorite" : "GameType",
          Value: gameType,
        });
      }
    });
    // let timeout: any = null;
    const searching = (_e: any) => {
      // clearTimeout(timeout);
      // timeout = setTimeout(() => {
      searchedGame.value = searchModel.value;
      handleSearchGame();
      // }, 800);
    };
    const gameReadyToRender = ref<Array<IGameBsi> | undefined>([]);
    const index = ref(0);
    const gameRender = computed(() => {
      const chunkSize = 24;
      const games = [];
      if (gameCollection.value !== undefined) {
        for (let i = 0; i < gameCollection.value.length; i += chunkSize) {
          const chunk: Array<IGameBsi> | undefined = gameCollection.value.slice(
            i,
            i + chunkSize
          );
          games.push(chunk);
        }
      }
      return games;
    });
    const gameRenderer = () => {
      gameRender.value[index.value].forEach((item) => {
        gameReadyToRender.value?.push(item);
      });
    };
    watch(gameRender, () => {
      gameReadyToRender.value = [];
      index.value = 0;
      if (gameRender.value.length) {
        gameRenderer();
      }
    });
    const gameLoading = () => {
      index.value += 1;
      if (index.value < gameRender.value.length) {
        gameRenderer();
      }
    };
    const isImageVersionExist = (imageURL: string): string => {
      if (_.includes(imageURL, "?v=")) {
        return imageURL;
      }
      return `${imageURL}?v=${store.state.imageVersion}`;
    };
    return {
      filtered,
      isLoading,
      headerTab,
      gameTypes,
      providers,
      // initialGameEntry,
      tabInitial,
      providerModel,
      subTabInitial,
      authenticated,
      handleSelectedTabOption,
      handleGameEntryOpenWindow,
      handleGameClicked,
      Search,
      isSearching,
      toggleIsSearching,
      searchModel,
      searching,
      gameLoading,
      gameReadyToRender,
      isImageVersionExist,
      setAndUnsetGameToFavourite,
      redirectToLogin,
      checkIsFavourite,
      getAssetImage,
      gameCollection,
      updateSearchResult,
      gameInputRef,
    };
  },
});
</script>

<style lang="scss" scoped>
.game-container {
  @apply grid grid-cols-2 gap-[3vw] py-[3vw] px-[4vw] my-[12.8vw];
}

.search-field {
  @apply bg-white py-2 px-[4vw] w-full;

  :deep(.el-input) {
    @apply flex items-center justify-center mr-4;
    .el-input__inner {
      --el-input-border-color: transparent;
      --el-input-hover-border-color: transparent;
      --el-input-focus-border-color: transparent;
      @apply h-full text-[4vw];

      &:hover {
        box-shadow: 0 0 0 1px transparent inset;
      }
    }
  }
}
:deep(.el-input__inner) {
  background: unset;
}
</style>
